/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

var EXPORTED_SYMBOLS = ["cacheAddons", "getAddonName", "allAddons", "haveCache"];

Components.utils.import("resource://gre/modules/AddonManager.jsm");

var cachedAddons = {};

function cacheAddons() {
  if (!haveCache()) {
    dump("cache!\n");
    AddonManager.getAddonsByTypes(["extension"], function (addons) {
      for(let i = 0; i < addons.length; i++) {
        let addon = addons[i];
        cachedAddons[addon.name] = addon.getResourceURI("").spec; //.QueryInterface(Components.interfaces.nsIFileURL);
      }
    });
  } else {
    dump("have cache!\n");
  }
}

function getAddonName(url) {
  let res = "";
  for (name in cachedAddons) {
    if (url.indexOf(cachedAddons[name]) != -1) {
      res = name;
      break;
    }
  }
  
  return res;
}

function allAddons() {
  return cachedAddons;
}

function haveCache() {
  return Object.keys(cachedAddons).length > 0;
}